from setuptools import setup, find_packages

try:
    import py2exe
    py2exe  # To make pyflakes happy.
except ImportError:
    pass


setup(
    name="tabakrolletjie",
    version="1.0.0",
    url='http://ctpug.org.za/gitweb/tabakrolletjie',
    license='BSD',
    description="An entry for Pyweek 22.",
    long_description=open('README.txt', 'r').read(),
    author='CTPUG',
    author_email='ctpug@googlegroups.com',
    packages=find_packages(),
    include_package_data=True,
    install_requires=[
        'pygame',
        'pymunk',
    ],
    classifiers=[
        'Development Status :: 4 - Beta',
        'Intended Audience :: End Users/Desktop',
        'License :: OSI Approved :: ISC License (ISCL)',
        'Operating System :: POSIX',
        'Operating System :: Microsoft :: Windows',
        'Programming Language :: Python',
        'Programming Language :: Python :: 2.7',
        'Topic :: Games/Entertainment',
    ],
    # py2exe
    windows=[{
        'script': 'scripts/tabakrolletjie',
        'icon_resources': [(0, "data/images/icons/tabakrolletjie_icon.ico")],
    }],
    options={
        'py2exe': {
            'skip_archive': 1,
            'dist_dir': 'dist/tabakrolletjie-1.0.0',
            'packages': [
                'logging', 'encodings', 'tabakrolletjie',
            ],
            'includes': [
                'pygame', 'pymunk',
            ],
            'excludes': [
                'numpy',
            ],
            'ignores': [
                # all database modules
                'pgdb', 'Sybase', 'adodbapi',
                'kinterbasdb', 'psycopg', 'psycopg2', 'pymssql',
                'sapdb', 'pysqlite2', 'sqlite', 'sqlite3',
                'MySQLdb', 'MySQLdb.connections',
                'MySQLdb.constants.CR', 'MySQLdb.constants.ER',
                # old datetime equivalents
                'DateTime', 'DateTime.ISO',
                'mx', 'mx.DateTime', 'mx.DateTime.ISO',
                # email modules
                'email.Generator', 'email.Iterators', 'email.Utils',
            ],
        },
    }
)
