""" Custom events. """

import pygame.event
import pygame.locals as pgl


class TabakEvent(object):
    TYPE = "UNKNOWN"
    ATTRIBUTES = set()

    @classmethod
    def post(cls, **attributes):
        assert set(attributes.keys()) == cls.ATTRIBUTES
        ev = pygame.event.Event(
            pgl.USEREVENT, tabak_type=cls.TYPE, **attributes)
        pygame.event.post(ev)

    @classmethod
    def matches(cls, ev):
        return (ev.type == pgl.USEREVENT and ev.tabak_type == cls.TYPE)


class QuitEvent(TabakEvent):
    TYPE = "QUIT"


class SceneChangeEvent(TabakEvent):
    TYPE = "SCENE_CHANGE"
    ATTRIBUTES = {'scene'}
